const express = require("express");

const router = express.Router();
const pharmacyController = require("../services/pharmacy");
const { validateLocation } = require("../validations/pharmacyV");

router
  .route("/")
  .get(
    validateLocation,
    pharmacyController.filterObj,
    pharmacyController.getAll
  )
  .post(pharmacyController.createOne);

router
  .route("/:id")
  .get(pharmacyController.getOne)
  .put(pharmacyController.updateOne)
  .delete(pharmacyController.deleteOne);

module.exports = router;
