const RelatedMessage = require("../models/relatedMessage");

exports.createOne = async (data) => {
  const relatedMessage = await RelatedMessage.create(data);
  if (!relatedMessage) {
    throw new Error("error in creating relatedMessage ");
  }
  return relatedMessage._id;
};

exports.getOne = async (id) => {
  const relatedMessage = await RelatedMessage.findById(id);
  return relatedMessage;
};

exports.pushPharmacyToDoc = async (id, pharmacyId) => {
  const doc = await RelatedMessage.updateOne(
    { _id: id }, //filter
    {
      $push: { pharmacies: pharmacyId }, //operation
    },
    { new: true } //to return the updated doc
  );
  if (!doc) {
    console.log(
      "error in pushing pharmacy to relatedMessage or relatedMessage not found"
    );
    return false;
  }
  console.log("pharmacy pushed to relatedMessage");
  return true;
};

exports.getRelatedMessages = async (requestId) => {
  const replies = await RelatedMessage.findOne({ requestId }).populate(
    "pharmacies"
  );
  return replies;
};

exports.deleteRelatedMessage = async (requestId) => {
  await RelatedMessage.delete({ requestId });
  return true;
};
