const relatedMessageService = require("./relatedMessage");
const Pharmacy = require("../models/pharmacy");
const mongoose = require("mongoose");
const { json } = require("express");
// Your AccountSID and Auth Token from console.twilio.com
//my account
// const accountSid = "ACe08945e6fc92b76b6fc24fe99e26a14d";
// const authToken = "ab61a313a1a52fa3675c1dffc9de5dc1";
//USf8552e39f320f2745584c9f3a542b4d6.
// client account
const accountSid = "AC43e90ff90daa7925ae7873f5ce83489b";
const authToken = "30a39636a3907cdbba8f26eda7fe5642";

const client = require("twilio")(accountSid, authToken);

// exports.sendMessage = async (data) => {
//   try {
//     const message = await client.messages.create({
//       body: "this is a test message",
//       to: `whatsapp:+201154765066`, // Text your number
//       // from: "whatsapp:+14155238886", // From a valid Twilio number
//       from: "whatsapp:+12526288120", // From a client number number
//     });
//     console.log(`message sent ` + JSON.stringify(message));
//   } catch (err) {
//     console.log(`error in sending message`, err.message);
//   }
// };
exports.sendMessage = async (data) => {
  try {
    const message = await client.messages.create({
      body: data.message,
      to: `whatsapp:${data.to}` || `whatsapp:+201154765066`, // Text your number
      // from: "whatsapp:+14155238886", // From a valid Twilio number
      from: "whatsapp:+12526288120", // From a client number number
    });
    console.log(`message sent` + message.sid);
  } catch (err) {
    console.log(`error in sending message`, err.message);
  }
};

exports.handleWhatsappReplies = async (replyBody) => {
  console.log(replyBody);
  const { Body: reply, From } = replyBody;
  const replyParts = reply.split("-");
  const pharmacyPhone = From.split(":")[1];
  //**validate the reply
  //1-Check if reply has exactly two parts: [requestId, answer]-
  //validation -------------------------
  if (replyParts.length !== 2) {
    await this.sendMessage({
      message: "Please enter the right format:\nid yes or id no",
      to: pharmacyPhone,
    });
    return;
  }
  const [requestRelatedMessagesId, answer] = replyParts;

  //2- Validate requestId as a MongoDB ObjectId
  if (!mongoose.Types.ObjectId.isValid(requestRelatedMessagesId)) {
    await this.sendMessage({
      message:
        "Invalid id format. Please use a valid id format:\nid yes or id no",
      to: pharmacyPhone,
    });
    return;
  }

  //3- Validate answer to be either 'yes' or 'no'
  if (!["yes", "no"].includes(answer.toLowerCase())) {
    await this.sendMessage({
      message:
        "Answer must be 'yes' or 'no'. Please use the format:\nid yes or id no",
      to: pharmacyPhone,
    });
    return;
  }
  //--------------------------------------------
  //check if answer is yes
  if (answer.toLowerCase() === "yes") {
    const pharmacyPhoneLastDigits = pharmacyPhone.slice(-8); // Adjust the length as necessary

    const pharmacy = await Pharmacy.findOne({
      $or: [
        { phone: pharmacyPhone }, // Exact match
        { phone: { $regex: pharmacyPhoneLastDigits + "$" } }, // Ends with last digits
      ],
    });
    if (!pharmacy) {
      await this.sendMessage({
        message: "You are not registered in our system",
        to: pharmacyPhone,
      });
      return;
    }
    //2- push this pharmacy to the socket  || push it to data base
    await relatedMessageService.pushPharmacyToDoc(
      requestRelatedMessagesId,
      pharmacy._id
    );
  }
};
