const { check, query } = require("express-validator");
const { validationResult } = require("express-validator");

exports.validateLocation = [
  query("location")
    .optional()
    .custom((value) => {
      const [longitude, latitude] = value.split(",");
      if (
        longitude < -180 ||
        longitude > 180 ||
        latitude < -90 ||
        latitude > 90
      ) {
        throw new Error(
          "Invalid location , latitude must be between -90 and 90, longitude must be between -180 and 180"
        );
      }
      return true;
    }),
  (req, res, next) => {
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
      return res.status(400).json({ errors: errors.array() });
    }
    next();
  },
];
