const { check } = require("express-validator");
const { validationResult } = require("express-validator");

exports.validateRequest = [
  check("userName").notEmpty().withMessage("userName is required"),
  check("userPhone").notEmpty().withMessage("userPhone is required"),
  check("medicine").notEmpty().withMessage("medicine is required"),
  check("pharmaciesIds").notEmpty().withMessage("pharmaciesIds is required"),
  (req, res, next) => {
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
      return res.status(400).json({ errors: errors.array() });
    }
    next();
  },
];
